plugins {
    id("com.android.application") // Apply the Android application plugin
    id("com.google.android.libraries.mapsplatform.secrets-gradle-plugin") // Apply the google maps plugin
}

android {
    namespace = "com.example.epl498_application" // Define the package namespace
    // Configure Android SDK and build settings
    compileSdk = 33 // Compile against Android SDK version 33

    /**
     * WARNING: In general, do not change the versions of either the SDK or packages without
     * first confirming their compatibility. Not all versions are compatible with every package
     * or SDK, and simply using the newest version does not guarantee compatibility.
     */
    defaultConfig {
        applicationId = "com.example.epl498_application" // Package name of the application
        minSdk = 24 // Minimum supported Android version (API level)
        targetSdk = 33 // Target Android version
        versionCode = 1 // Version code for the app
        versionName = "1.0" // Version name for the app

        testInstrumentationRunner = "androidx.test.runner.AndroidJUnitRunner" // Test runner for unit tests
    }

    buildTypes {
        release {
            isMinifyEnabled = false // Disable code minification for release builds
            proguardFiles(
                getDefaultProguardFile("proguard-android-optimize.txt"),
                "proguard-rules.pro"
            ) // Configuration for ProGuard, a code shrinker and obfuscator
        }
    }
    compileOptions {
        sourceCompatibility = JavaVersion.VERSION_1_8 // Source code compatibility (Java 8)
        targetCompatibility = JavaVersion.VERSION_1_8 // Target compatibility (Java 8)
    }
    buildFeatures {
        viewBinding = true
    }
}
// Define project dependencies
dependencies {

    // AndroidX AppCompat library
    implementation("androidx.appcompat:appcompat:1.6.1")
    // Material Design components
    implementation("com.google.android.material:material:1.8.0")
    // Google Play services for location [This wasn't added by default]
    implementation("com.google.android.gms:play-services-location:21.0.1")
    // Google Play services for maps [This wasn't added by default]
    implementation("com.google.android.gms:play-services-maps:18.1.0")
    // ConstraintLayout
    implementation("androidx.constraintlayout:constraintlayout:2.1.4")
    // Navigation fragment
    implementation("androidx.navigation:navigation-fragment:2.5.3")
    // Navigation UI components
    implementation("androidx.navigation:navigation-ui:2.5.3")
    // JUnit for unit testing
    testImplementation("junit:junit:4.13.2")
    // AndroidX JUnit extensions
    androidTestImplementation("androidx.test.ext:junit:1.1.5")
    // Espresso for UI testing
    androidTestImplementation("androidx.test.espresso:espresso-core:3.5.1")
}